/*
Code copyright (C) 2003 Subhobroto Sinha <pasha_3d[at]yahoo[dot]com>
Verbatim copying of this code  in any media is permitted provided this comment and the copyright is maintained.
*/
#include <windows.h>
#include <shlobj.h>
#include <objbase.h>
#include <shellapi.h>
#include <string.h>

HRESULT GetLinkInfo(HWND hWnd,LPCTSTR lpszLinkName,LPSTR lpszPath);
BOOL DriverGetLinkInfo(LPCTSTR lpszLinkName);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	if(!DriverGetLinkInfo(lpCmdLine)) return -1;
	return 0;
}
BOOL DriverGetLinkInfo(LPCTSTR lpszLinkName)
{
	/*
	Driver function for GetLinkInfo() function.
	*/
	char szPath[MAX_PATH+1]={0};
	if(SUCCEEDED(GetLinkInfo(NULL,lpszLinkName,szPath)))
	{
		//MessageBox(NULL,szPath,lpszLinkName,MB_OK);
		HANDLE hFile=CreateFile("WineWorksResolvedPath.dat",GENERIC_WRITE,FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(!hFile) return FALSE;
		DWORD dwT;
		if(!WriteFile(hFile,szPath,strlen(szPath),&dwT,NULL)) return FALSE;
		CloseHandle(hFile);
	}
	else 
	{
		//MessageBox(NULL,lpszLinkName,"Error resolving shortcut",MB_OK);		
	}
	return FALSE;
}

/* GetLinkInfo() fills the filename and path buffer with relevant information.
hWnd -> calling application's window handle.
lpszLinkName -> name of the link file passed into the function.
lpszPath -> the buffer that receives the file's path name.
*/
HRESULT GetLinkInfo(HWND hWnd,LPCTSTR lpszLinkName,LPSTR lpszPath)
{
	HRESULT hres;
	IShellLink *pShLink;
	WIN32_FIND_DATA wfd;
	CoInitialize(NULL);
	hres=CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(LPVOID *)&pShLink);
	
	if(SUCCEEDED(hres))
	{
		IPersistFile *ppf;
		hres = pShLink->QueryInterface(IID_IPersistFile,(void**)&ppf);
		if(SUCCEEDED(hres))
		{
			WCHAR wsz[MAX_PATH+1];// buffer for Unicode string
			MultiByteToWideChar(CP_ACP,0,lpszLinkName,-1/*(strlen(lpszLinkName)+1)*/,/*(LPWSTR)&*/wsz,sizeof(wsz));// Convert the given link name string to a wide character string.
			hres=ppf->Load(wsz,STGM_READ); //Load the shortcut. Updated Wine(20030813) fails here...
			if(hres!=S_OK) MessageBox(NULL,"IPersistFile::Load() failed !","Error",MB_OK);
			if(SUCCEEDED(hres))
			{
				hres=pShLink->Resolve(hWnd,SLR_ANY_MATCH|SLR_NO_UI);
				if(SUCCEEDED(hres)) hres=pShLink->GetPath(lpszPath,MAX_PATH,&wfd,SLGP_UNCPRIORITY); // Get the path of the file the link points to.
			}
			ppf->Release();
		}
		pShLink->Release();
	}
	CoUninitialize();
	return hres;
}

